#ifndef CONNECT4_CLIENT_H
#define CONNECT4_CLIENT_H

#include <afblib/inbuf.h>
#include <afblib/outbuf.h>
#include <afblib/strlist.h>
#include <stdbool.h>
#include "connect4.h"
#include "connect4_packets.h"

struct connect4_service {
   int fd;
   inbuf ibuf;
   outbuf obuf;
};

void c4_init(struct connect4_service* c4, int fd);
bool c4_login(struct connect4_service* c4, char* login);
bool c4_users(struct connect4_service* c4, strlist* users);
bool c4_play(struct connect4_service* c4,
   connect4_board* board, char** opponent);
bool c4_invite(struct connect4_service* c4, char* player,
   connect4_board* board);
bool c4_move(struct connect4_service* c4,
   connect4_board* board, connect4_move move);
bool c4_quit(struct connect4_service* c4);
void c4_hangup(struct connect4_service* c4);

#endif
