#include <assert.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <afblib/hostport.h>
#include "connect4.h"
#include "connect4_client.h"
#include "connect4_player.h"

void run_player(char* hport, char* login, move_handler suggest_move) {
   hostport hp = {0};
   if (!parse_hostport(hport, &hp, CONNECT4_PORT)) return;
   int fd;
   if ((fd = socket(hp.domain, SOCK_STREAM, hp.protocol)) < 0) return;
   if (connect(fd, (struct sockaddr *) &hp.addr, hp.namelen) < 0) return;

   struct connect4_service service = {0};
   c4_init(&service, fd);

   if (!c4_login(&service, login)) {
      c4_hangup(&service);
      return;
   }

   for(;;) {
      connect4_board board = {0};
      char* opponent;
      if (!c4_play(&service, &board, &opponent)) {
	 c4_hangup(&service);
	 return;
      }
      free(opponent);
      while (!connect4_finished(&board)) {
	 connect4_move move = (*suggest_move)(&board);
	 assert(connect4_valid_move(&board, move));
	 if (!c4_move(&service, &board, move)) break;
      }
   }
}
