#include <stdio.h>
#include <stdlib.h>
#include <afblib/hostport.h>
#include <afblib/strlist.h>
#include "connect4_client.h"

int main(int argc, char** argv) {
   char* cmdname = *argv++; --argc;
   if (argc != 1) {
      fprintf(stderr, "Usage: %s hostport\n", cmdname);
      exit(1);
   }
   char* hport = *argv++; --argc;

   hostport hp = {0};
   if (!parse_hostport(hport, &hp, CONNECT4_PORT)) {
      perror(hport);
      exit(1);
   }
   int fd;
   if ((fd = socket(hp.domain, SOCK_STREAM, hp.protocol)) < 0) {
      perror("socket"); exit(1);
   }
   if (connect(fd, (struct sockaddr *) &hp.addr, hp.namelen) < 0) {
      perror(hport); exit(1);
   }

   struct connect4_service service = {0};
   c4_init(&service, fd);

   stralloc login = {0};
   char* cp = getenv("USER"); if (cp) stralloc_copys(&login, cp);
   stralloc_cats(&login, "[");
   stralloc_catint(&login, getpid());
   stralloc_cats(&login, "]");
   char hostname[256];
   if (gethostname(hostname, sizeof hostname) == 0) {
      stralloc_cats(&login, "@");
      stralloc_cats(&login, hostname);
   }
   stralloc_0(&login);

   if (!c4_login(&service, login.s)) {
      fprintf(stderr, "Unable to login to connect4 service\n");
      c4_hangup(&service);
      exit(1);
   }

   strlist users = {0};
   if (!c4_users(&service, &users)) {
      fprintf(stderr, "Unable to obtain list of users\n");
      c4_hangup(&service);
      exit(1);
   }

   for (int index = 0; index < users.len; ++index) {
      puts(users.list[index]); free(users.list[index]);
   }
   strlist_free(&users);

   c4_quit(&service);
   c4_hangup(&service);
}
