#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "connect4.h"
#include "connect4_player.h"

connect4_move suggest_move(connect4_board* board) {
   connect4_moves_set moves = connect4_valid_moves(board);
   unsigned int count = 0;
   connect4_move candidates[COLUMNS];
   for (int move = 1; move <= COLUMNS; ++move) {
      if (moves & 1<<(move-1)) candidates[count++] = move;
   }
   assert(count > 0);
   return candidates[rand() % count];
}

int main(int argc, char** argv) {
   char* cmdname = *argv++; --argc;
   if (argc != 2) {
      fprintf(stderr, "Usage: %s hostport login\n", cmdname);
      exit(1);
   }
   char* hport = *argv++; --argc;
   char* login = *argv++; --argc;

   srand(getpid());
   run_player(hport, login, suggest_move);
}
