#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "connect4.h"
#include "connect4_player.h"
#include "connect4_eval.h"

connect4_move suggest_move(connect4_board* board) {
   int best_value = INFINITELY_BAD; connect4_move best_candidate = 0;
   enum connect4_slot me = connect4_next(board);
   connect4_moves_set moves = connect4_valid_moves(board);
   for (int move = 1; move <= COLUMNS; ++move) {
      if (moves & 1<<(move-1)) {
	 int evaluation = connect4_recursive_eval(*board, move, 4, me);
	 if (best_candidate == 0 || evaluation > best_value) {
	    best_value = evaluation;
	    best_candidate = move;
	 }
      }
   }
   assert(best_candidate > 0);
   return best_candidate;
}

int main(int argc, char** argv) {
   char* cmdname = *argv++; --argc;
   if (argc != 2) {
      fprintf(stderr, "Usage: %s hostport login\n", cmdname);
      exit(1);
   }
   char* hport = *argv++; --argc;
   char* login = *argv++; --argc;

   srand(getpid());
   run_player(hport, login, suggest_move);
}
